#include "cps3.h"

static struct BurnInputInfo cps3InputList[] = {
	{"P1 Up",		BIT_DIGITAL,	Cps3But1 +  0,	"p1 up"},
	{"P1 Down",		BIT_DIGITAL,	Cps3But1 +  1,	"p1 down"},
	{"P1 Left",		BIT_DIGITAL,	Cps3But1 +  2,	"p1 left"},
	{"P1 Right",	BIT_DIGITAL,	Cps3But1 +  3,	"p1 right"},
	{"P1 Button 1",	BIT_DIGITAL,	Cps3But1 +  4,	"p1 fire 1"},
	{"P1 Button 2",	BIT_DIGITAL,	Cps3But1 +  5,	"p1 fire 2"},
	{"P1 Button 3",	BIT_DIGITAL,	Cps3But1 +  6,	"p1 fire 3"},

	{"P2 Up",		BIT_DIGITAL,	Cps3But1 +  8,	"p2 up"},
	{"P2 Down",		BIT_DIGITAL,	Cps3But1 +  9,	"p2 down"},
	{"P2 Left",		BIT_DIGITAL,	Cps3But1 + 10,	"p2 left"},
	{"P2 Right",	BIT_DIGITAL,	Cps3But1 + 11,	"p2 right"},
	{"P2 Button 1",	BIT_DIGITAL,	Cps3But1 + 12,	"p2 fire 1"},
	{"P2 Button 2",	BIT_DIGITAL,	Cps3But1 + 13,	"p2 fire 2"},
	{"P2 Button 3",	BIT_DIGITAL,	Cps3But1 + 14,	"p2 fire 3"},

	{"Service",		BIT_DIGITAL,	Cps3But2 +  0,	"service"},
	//{"Service",	BIT_DIGITAL,	Cps3But2 +  1,	"service"},
	{"P1 Coin",		BIT_DIGITAL,	Cps3But2 +  8,	"p1 coin"},
	{"P2 Coin",		BIT_DIGITAL,	Cps3But2 +  9,	"p2 coin"},
	{"P2 Button 6",	BIT_DIGITAL,	Cps3But2 + 10,	"p2 fire 6"},
	{"P1 Start",	BIT_DIGITAL,	Cps3But2 + 12,	"p1 start"},
	{"P2 Start",	BIT_DIGITAL,	Cps3But2 + 13,	"p2 start"},

	{"P1 Button 6",	BIT_DIGITAL,	Cps3But3 +  1,	"p1 fire 6"},
	{"P1 Button 5",	BIT_DIGITAL,	Cps3But3 +  2,	"p1 fire 5"},
	{"P1 Button 4",	BIT_DIGITAL,	Cps3But3 +  3,	"p1 fire 4"},
	{"P2 Button 4",	BIT_DIGITAL,	Cps3But3 +  4,	"p2 fire 4"},
	{"P2 Button 5",	BIT_DIGITAL,	Cps3But3 +  5,	"p2 fire 5"},
		
	{"Reset",		BIT_DIGITAL,	&cps3_reset,	"reset"},
};

STDINPUTINFO(cps3);

static struct BurnRomInfo sfiiinRomDesc[] = {

	{ "sfiii_asia_nocd.29f400.u2",	  
					  0x080000, 0x73e32463, BRF_ESS | BRF_BIOS },	// SH-2 Bios
	 
	{ "10",			  0x800000, 0xe896dc27, BRF_ESS | BRF_PRG },	// SH-2 Code
	
	{ "30",			  0x800000, 0x98c2d07c, BRF_GRA },				// cd content region
	{ "31",			  0x800000, 0x7115a396, BRF_GRA }, 
	{ "40",			  0x800000, 0x839f0972, BRF_GRA },
	{ "41",			  0x800000, 0x8a8b252c, BRF_GRA }, 
	{ "50",			  0x400000, 0x58933dc2, BRF_GRA },
};

STD_ROM_PICK(sfiiin);
STD_ROM_FN(sfiiin);

static struct BurnRomInfo sfiii3nRomDesc[] = {

	{ "sfiii3_japan_nocd.29f400.u2",	  
					  0x080000, 0x1edc6366, BRF_ESS | BRF_BIOS },	// SH-2 Bios
	 
	{ "10",			  0x800000, 0x77233d39, BRF_ESS | BRF_PRG },	// SH-2 Code
	{ "20",			  0x800000, 0x5ca8faba, BRF_ESS | BRF_PRG }, 
	
	{ "30",			  0x800000, 0xb37cf960, BRF_GRA },
	{ "31",			  0x800000, 0x450ec982, BRF_GRA }, 
	{ "40",			  0x800000, 0x632c965f, BRF_GRA },
	{ "41",			  0x800000, 0x7a4c5f33, BRF_GRA }, 
	{ "50",			  0x800000, 0x8562358e, BRF_GRA },
	{ "51",			  0x800000, 0x7baf234b, BRF_GRA }, 
	{ "60",			  0x800000, 0xbc9487b7, BRF_GRA },
	{ "61",			  0x800000, 0xb813a1b1, BRF_GRA }, 
};

STD_ROM_PICK(sfiii3n);
STD_ROM_FN(sfiii3n);

static struct BurnRomInfo jojonRomDesc[] = {

	{ "jojo_asia_nocd.29f400.u2",	  
					  0x080000, 0x05b4f953, BRF_ESS | BRF_BIOS },	// SH-2 Bios
	 
	{ "10",			  0x800000, 0xe40dc123, BRF_ESS | BRF_PRG },	// SH-2 Code
	{ "20",			  0x800000, 0x0571e37c, BRF_ESS | BRF_PRG }, 
	
	{ "30",			  0x800000, 0x1d99181b, BRF_GRA },
	{ "31",			  0x800000, 0x6889fbda, BRF_GRA }, 
	{ "40",			  0x800000, 0x8069f9de, BRF_GRA },
	{ "41",			  0x800000, 0x9c426823, BRF_GRA }, 
	{ "50",			  0x400000, 0x1c749cc7, BRF_GRA },
};

STD_ROM_PICK(jojon);
STD_ROM_FN(jojon);

static struct BurnRomInfo jojoaltnRomDesc[] = {

	{ "jojo_asia_nocd.29f400.u2",	  
					  0x080000, 0x05b4f953, BRF_ESS | BRF_BIOS },	// SH-2 Bios
	 
	{ "10",			  0x800000, 0xbc612872, BRF_ESS | BRF_PRG },	// SH-2 Code
	{ "20",			  0x800000, 0x0e1daddf, BRF_ESS | BRF_PRG }, 
	
	{ "30",			  0x800000, 0x1d99181b, BRF_GRA },				// cd content region
	{ "31",			  0x800000, 0x6889fbda, BRF_GRA }, 
	{ "40",			  0x800000, 0x8069f9de, BRF_GRA },
	{ "41",			  0x800000, 0x9c426823, BRF_GRA }, 
	{ "50",			  0x400000, 0x1c749cc7, BRF_GRA },
};

STD_ROM_PICK(jojoaltn);
STD_ROM_FN(jojoaltn);

static int sfiiiInit()
{
	cps3_key1 = 0xb5fe053e;
	cps3_key2 = 0xfc03925a;
	cps3_isSpecial = 0;
	
	cps3_bios_test_hack = 0x000166b4;
	cps3_game_test_hack = 0x063cdff4;
	
	cps3_speedup_ram_address	= 0x0000cc6c; 
	cps3_speedup_code_address	= 0x06000884;

	return cps3Init();
}

static int sfiii3Init()
{
	cps3_key1 = 0xa55432b4;
	cps3_key2 = 0x0c129981;
	cps3_isSpecial = 0;
	
	cps3_bios_test_hack = 0x00011c44;
	cps3_game_test_hack = 0x0613ab48;
	
	cps3_speedup_ram_address	= 0x0000d794; 
	cps3_speedup_code_address	= 0x06000884;

	return cps3Init();
}

static int jojoInit()
{
	cps3_key1 = 0x02203ee3;
	cps3_key2 = 0x01301972;
	cps3_isSpecial = 0;
	
	cps3_bios_test_hack = 0x00011c2c;
	cps3_game_test_hack = 0x06172568;
	
	cps3_speedup_ram_address	= 0x000223c0; 
	cps3_speedup_code_address	= 0x0600065c;
	
	return cps3Init();
}

struct BurnDriver BurnDrvSfiiin = {
	"sfiiin", NULL, NULL, "1997",
	"Street Fighter III: New Generation (Asia, 970204, NO CD)\0", NULL, "Capcom", "misc",
	NULL, NULL, NULL, NULL,
	BDF_GAME_WORKING | BDF_16BIT_ONLY, 2, HARDWARE_MISC_MISC,
	NULL, sfiiinRomInfo, sfiiinRomName, cps3InputInfo, NULL,
	sfiiiInit, cps3Exit, cps3Frame, NULL, cps3Scan, &cps3_palette_change, 
	384, 224, 4, 3
};
		
struct BurnDriver BurnDrvSfiii3n = {
	"sfiii3n", NULL, NULL, "1999",
	"Street Fighter III 3rd Strike: Fight for the Future (Japan, 990512, NO CD)\0", NULL, "Capcom", "misc",
	NULL, NULL, NULL, NULL,
	BDF_GAME_WORKING | BDF_16BIT_ONLY, 2, HARDWARE_MISC_MISC,
	NULL, sfiii3nRomInfo, sfiii3nRomName, cps3InputInfo, NULL,
	sfiii3Init, cps3Exit, cps3Frame, NULL, cps3Scan, &cps3_palette_change, 
	384, 224, 4, 3
};

struct BurnDriver BurnDrvJojon = {
	"jojon", NULL, NULL, "1998",
	"JoJo's Venture / JoJo no Kimyouna Bouken (Asia, 981202, NO CD)\0", NULL, "Capcom", "misc",
	NULL, NULL, NULL, NULL,
	BDF_GAME_WORKING | BDF_16BIT_ONLY, 2, HARDWARE_MISC_MISC,
	NULL, jojonRomInfo, jojonRomName, cps3InputInfo, NULL,
	jojoInit, cps3Exit, cps3Frame, NULL, cps3Scan, &cps3_palette_change, 
	384, 224, 4, 3
};

struct BurnDriver BurnDrvJojoaltn = {
	"jojoaltn", "jojon", NULL, "1998",
	"JoJo's Venture / JoJo no Kimyouna Bouken (Asia, 990108, NO CD)\0", NULL, "Capcom", "misc",
	NULL, NULL, NULL, NULL,
	BDF_GAME_WORKING | BDF_16BIT_ONLY | BDF_CLONE, 2, HARDWARE_MISC_MISC,
	NULL, jojoaltnRomInfo, jojoaltnRomName, cps3InputInfo, NULL,
	jojoInit, cps3Exit, cps3Frame, NULL, cps3Scan, &cps3_palette_change, 
	384, 224, 4, 3
};
